/**
 * git do not control webim.config.js
 * everyone should copy webim.config.js to webim.config.js
 * and have their own configs.
 * In this way , others won't be influenced by this config while git pull.
 *
 */
// import config_env from '@/config/config'; // 配置项
// 这里引用模块在小程序下会报错，所以改成通过引用 globalData
const ENV = getApp().globalData.ENV;

console.log('ENVENVENV',ENV);
const ENV_CONFIG = {
    development: { // 开发环境
        imAppKey: '1104181212107132#honeycomb' // im
    },
    test: { // 测试环境
        imAppKey: '1104181212107132#formicary'

    },
    pre: { // 预发布环境
        imAppKey: '1104181212107132#vshop'

    },
    production: { // 生产环境
        imAppKey: '1104181212107132#vshop'

    }
};

const config_env = ENV_CONFIG[ENV]
// console.log('process.env', process.env, config_env)

// for react native
let location = {
	protocol: "https"
};

let config = {
	/*
	 * XMPP server
	 */
	xmppURL: "wss://im-api.easemob.com/ws/",
	// xmppURL: '172.17.3.122:5280',
	/*
	 * Backend REST API URL
	 */
	// apiURL: (location.protocol === 'https:' ? 'https:' : 'http:') + '//a1.easemob.com',
	// ios must be https!!! by lwz
	apiURL: "https://a1.easemob.com",
	// apiURL: (location.protocol === 'https:' ? 'https:' : 'http:') + '//172.17.3.155:8080',
	/*
	 * Application AppKey
	 */
	// appkey: "easemob-demo#chatdemoui",
	appkey: config_env.imAppKey,
	
	/*
	 * Whether to use HTTPS      '1177161227178308#xcx'
	 * @parameter {Boolean} true or false
	 */
	https: false,
	/*
	 * isMultiLoginSessions
	 * true: A visitor can sign in to multiple webpages and receive messages at all the webpages.
	 * false: A visitor can sign in to only one webpage and receive messages at the webpage.
	 */
	isMultiLoginSessions: false,
	/**
	 * Whether to use window.doQuery()
	 * @parameter {Boolean} true or false
	 */
	isWindowSDK: false,
	/**
	 * isSandBox=true:  xmppURL: 'im-api.sandbox.easemob.com',  apiURL: '//a1.sdb.easemob.com',
	 * isSandBox=false: xmppURL: 'im-api.easemob.com',          apiURL: '//a1.easemob.com',
	 * @parameter {Boolean} true or false
	 */
	isSandBox: false,
	/**
	 * Whether to console.log in strophe.log()
	 * @parameter {Boolean} true or false
	 */
	isDebug: false,
	/**
	 * will auto connect the xmpp server autoReconnectNumMax times in background when client is offline.
	 * won't auto connect if autoReconnectNumMax=0.
	 */
	autoReconnectNumMax: 15,
	/**
	 * the interval secons between each atuo reconnectting.
	 * works only if autoReconnectMaxNum >= 2.
	 */
	autoReconnectInterval: 2,
	/**
	 * webrtc supports WebKit and https only
	 */
	isWebRTC: false,
	/*
	 * Set to auto sign-in
	 */
	isAutoLogin: true
};

export default config;
